using System;
using System.Data.Common;
using System.Data.OleDb;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// Ʈ
    /// </summary>
    public class ControlForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// īװ ̺
        /// </summary>
        private Label categoryLabel;

        /// <summary>
        /// īװ ޺ ڽ
        /// </summary>
        private ComboBox categoryComboBox;

        /// <summary>
        /// ǰ ID ̺
        /// </summary>
        private Label productIDLabel;

        /// <summary>
        /// ǰ ID ؽƮ ڽ
        /// </summary>
        private TextBox productIDTextBox;

        /// <summary>
        /// ǰ ̺
        /// </summary>
        private Label productNameLabel;

        /// <summary>
        /// ǰ ؽƮ ڽ
        /// </summary>
        private TextBox productNameTextBox;

        /// <summary>
        /// ǰ  üũ ڽ
        /// </summary>
        private CheckBox discontinuedCheckBox;

        /// <summary>
        /// ܰ ̺
        /// </summary>
        private Label unitPriceLabel;

        /// <summary>
        /// ܰ NumericUpDown
        /// </summary>
        private NumericUpDown unitPriceNumericUpDown;

        /// <summary>
        /// ù° ư
        /// </summary>
        private Button firstButton;

        /// <summary>
        ///  ư
        /// </summary>
        private Button previousButton;

        /// <summary>
        /// ġ ؽƮ ڽ
        /// </summary>
        private TextBox positionTextBox;

        /// <summary>
        ///  ư
        /// </summary>
        private Button nextButton;

        /// <summary>
        ///  ư
        /// </summary>
        private Button lastButton;


        /// <summary>
        /// 
        /// </summary>
		private OleDbConnection connection;

        /// <summary>
        ///   
        /// </summary>
		private MasterDataSet masterDataSet;

        /// <summary>
        /// īװ ȸ 
        /// </summary>
		private OleDbCommand selectCategoryCommand;

        /// <summary>
        /// ǰ ȸ 
        /// </summary>
		private OleDbCommand selectProductCommand;

        /// <summary>
        /// īװ 
        /// </summary>
		private OleDbDataAdapter categoryAdapter;

        /// <summary>
        /// ǰ 
        /// </summary>
		private OleDbDataAdapter productAdatper;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - ControlForm()

        /// <summary>
        /// 
        /// </summary>
        public ControlForm()
        {
            InitializeComponent();

            #region  Ѵ.

            this.connection = new OleDbConnection();

            this.connection.ConnectionString = UIHelper.GetMSAccess2007ConnectionString("nwind.mdb");

            #endregion
            #region    Ѵ.

            this.masterDataSet = new MasterDataSet();

            this.masterDataSet.DataSetName = "Master";
            this.masterDataSet.Locale      = new System.Globalization.CultureInfo("en-US");
            this.masterDataSet.Namespace   = "http://www.tempuri.org/dsMaster.xsd";

            #endregion
            #region īװ ȸ  Ѵ.

            this.selectCategoryCommand = new OleDbCommand();

            this.selectCategoryCommand.Connection  = this.connection;
            this.selectCategoryCommand.CommandText = "SELECT CategoryID, CategoryName, Description FROM CategoriesByName";

            #endregion
            #region ǰ ȸ  Ѵ.

            this.selectProductCommand = new OleDbCommand();

            this.selectProductCommand.Connection  = this.connection;
            this.selectProductCommand.CommandText = "SELECT CategoryID, ProductID, ProductName, Discontinued, UnitPrice FROM Products ORDER BY ProductName";

            #endregion
            #region īװ ͸ Ѵ.

            this.categoryAdapter = new OleDbDataAdapter();

            this.categoryAdapter.SelectCommand = this.selectCategoryCommand;

            this.categoryAdapter.TableMappings.AddRange
            (
                new DataTableMapping[]
                {
                    new DataTableMapping
                    (
                        "Table",
                        "Categories",
                        new DataColumnMapping[]
                        {
                            new DataColumnMapping("CategoryID"  , "CategoryID"  ),
                            new DataColumnMapping("CategoryName", "CategoryName"),
                            new DataColumnMapping("Description" , "Description" )
                        }
                    )
                }
            );

            #endregion
            #region ǰ ͸ Ѵ.

            this.productAdatper = new OleDbDataAdapter();

            this.productAdatper.SelectCommand = this.selectProductCommand;

            this.productAdatper.TableMappings.AddRange
            (
                new DataTableMapping[]
                {
                    new DataTableMapping
                    (
                        "Table", 
                        "ProductsExtended", 
                        new DataColumnMapping[] 
                        {
                            new DataColumnMapping("ProductID"  , "ProductID"  ),
                            new DataColumnMapping("ProductName", "ProductName"),
                            new DataColumnMapping("SupplierID" , "SupplierID" ),
                            new DataColumnMapping("CategoryID" , "CategoryID" )
                        }
                    )
                }
            );

            #endregion

            #region ε Ѵ.

            this.categoryComboBox.DataSource    = this.masterDataSet;
            this.categoryComboBox.DisplayMember = "Categories.CategoryName";
            this.categoryComboBox.ValueMember   = "Categories.CategoryID";

            this.categoryComboBox.DataBindings.Add("SelectedValue", this.masterDataSet, "ProductsExtended.CategoryID");

            this.productIDTextBox.DataBindings.Add      (new Binding("Text"   , this.masterDataSet, "ProductsExtended.ProductID"   ));
            this.productNameTextBox.DataBindings.Add    (new Binding("Text"   , this.masterDataSet, "ProductsExtended.ProductName" ));
            this.discontinuedCheckBox.DataBindings.Add  (new Binding("Checked", this.masterDataSet, "ProductsExtended.Discontinued"));
            this.unitPriceNumericUpDown.DataBindings.Add(new Binding("Value"  , this.masterDataSet, "ProductsExtended.UnitPrice"   ));

            #endregion
            #region ̺Ʈ Ѵ.

            this.firstButton.Click    += firstButton_Click;
            this.previousButton.Click += previousButton_Click;
            this.nextButton.Click     += nextButton_Click;
            this.lastButton.Click     += lastButton_Click;

            #endregion

            this.categoryAdapter.Fill(this.masterDataSet.Categories      );
            this.productAdatper.Fill (this.masterDataSet.ProductsExtended);

            UpdatePosition();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        ////////////////////////////////////////////////////////////////////////////////////////// Event

        #region ó ư Ŭ óϱ - firstButton_Click(sender, e)

        /// <summary>
        /// ó ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
        private void firstButton_Click(object sender, EventArgs e)
        {
            BindingContext[this.masterDataSet, "ProductsExtended"].Position = 0;

            UpdatePosition();
        }

        #endregion
        #region  ư Ŭ óϱ - previousButton_Click(sender, e)

        /// <summary>
        ///  ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
        private void previousButton_Click(object sender, EventArgs e)
        {
            BindingContext[this.masterDataSet, "ProductsExtended"].Position -= 1;

            UpdatePosition();    
        }

        #endregion
        #region  ư Ŭ óϱ - nextButton_Click(sender, e)

        /// <summary>
        ///  ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
        private void nextButton_Click(object sender, EventArgs e)
        {
            BindingContext[this.masterDataSet, "ProductsExtended"].Position += 1;

            UpdatePosition();    
        }

        #endregion
        #region  ư Ŭ óϱ - lastButton_Click(sender, e)
        
        /// <summary>
        ///  ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
        private void lastButton_Click(object sender, EventArgs e)
        {
            BindingContext[this.masterDataSet, "ProductsExtended"].Position = BindingContext[this.masterDataSet, "ProductsExtended"].Count - 1;

            UpdatePosition();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Function

        #region Ʈ ʱȭ ϱ - InitializeComponent()

        /// <summary>
        /// Ʈ ʱȭ ϱ
        /// </summary>
        private void InitializeComponent()
        {
            this.categoryLabel = new System.Windows.Forms.Label();
            this.categoryComboBox = new System.Windows.Forms.ComboBox();
            this.productIDLabel = new System.Windows.Forms.Label();
            this.productIDTextBox = new System.Windows.Forms.TextBox();
            this.productNameLabel = new System.Windows.Forms.Label();
            this.productNameTextBox = new System.Windows.Forms.TextBox();
            this.discontinuedCheckBox = new System.Windows.Forms.CheckBox();
            this.unitPriceLabel = new System.Windows.Forms.Label();
            this.unitPriceNumericUpDown = new System.Windows.Forms.NumericUpDown();
            this.firstButton = new System.Windows.Forms.Button();
            this.previousButton = new System.Windows.Forms.Button();
            this.positionTextBox = new System.Windows.Forms.TextBox();
            this.nextButton = new System.Windows.Forms.Button();
            this.lastButton = new System.Windows.Forms.Button();
            ((System.ComponentModel.ISupportInitialize)(this.unitPriceNumericUpDown)).BeginInit();
            this.SuspendLayout();
            // 
            // categoryLabel
            // 
            this.categoryLabel.Font = new System.Drawing.Font("ڵ", 12F);
            this.categoryLabel.Location = new System.Drawing.Point(20, 20);
            this.categoryLabel.Margin = new System.Windows.Forms.Padding(0);
            this.categoryLabel.Name = "categoryLabel";
            this.categoryLabel.Size = new System.Drawing.Size(80, 23);
            this.categoryLabel.TabIndex = 0;
            this.categoryLabel.Text = "īװ";
            this.categoryLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // categoryComboBox
            // 
            this.categoryComboBox.Location = new System.Drawing.Point(100, 20);
            this.categoryComboBox.Name = "categoryComboBox";
            this.categoryComboBox.Size = new System.Drawing.Size(121, 24);
            this.categoryComboBox.TabIndex = 1;
            // 
            // productIDLabel
            // 
            this.productIDLabel.Font = new System.Drawing.Font("ڵ", 12F);
            this.productIDLabel.Location = new System.Drawing.Point(20, 50);
            this.productIDLabel.Margin = new System.Windows.Forms.Padding(0);
            this.productIDLabel.Name = "productIDLabel";
            this.productIDLabel.Size = new System.Drawing.Size(80, 23);
            this.productIDLabel.TabIndex = 2;
            this.productIDLabel.Text = "ǰ ID";
            this.productIDLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // productIDTextBox
            // 
            this.productIDTextBox.Location = new System.Drawing.Point(100, 50);
            this.productIDTextBox.Name = "productIDTextBox";
            this.productIDTextBox.Size = new System.Drawing.Size(121, 23);
            this.productIDTextBox.TabIndex = 3;
            // 
            // productNameLabel
            // 
            this.productNameLabel.Font = new System.Drawing.Font("ڵ", 12F);
            this.productNameLabel.Location = new System.Drawing.Point(20, 80);
            this.productNameLabel.Margin = new System.Windows.Forms.Padding(0);
            this.productNameLabel.Name = "productNameLabel";
            this.productNameLabel.Size = new System.Drawing.Size(80, 23);
            this.productNameLabel.TabIndex = 4;
            this.productNameLabel.Text = "ǰ";
            this.productNameLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // productNameTextBox
            // 
            this.productNameTextBox.Location = new System.Drawing.Point(100, 80);
            this.productNameTextBox.Name = "productNameTextBox";
            this.productNameTextBox.Size = new System.Drawing.Size(350, 23);
            this.productNameTextBox.TabIndex = 5;
            // 
            // discontinuedCheckBox
            // 
            this.discontinuedCheckBox.Font = new System.Drawing.Font("ڵ", 12F);
            this.discontinuedCheckBox.Location = new System.Drawing.Point(100, 110);
            this.discontinuedCheckBox.Margin = new System.Windows.Forms.Padding(0);
            this.discontinuedCheckBox.Name = "discontinuedCheckBox";
            this.discontinuedCheckBox.Size = new System.Drawing.Size(60, 23);
            this.discontinuedCheckBox.TabIndex = 6;
            this.discontinuedCheckBox.Text = "ǰ";
            // 
            // unitPriceLabel
            // 
            this.unitPriceLabel.Font = new System.Drawing.Font("ڵ", 12F);
            this.unitPriceLabel.Location = new System.Drawing.Point(20, 140);
            this.unitPriceLabel.Margin = new System.Windows.Forms.Padding(0);
            this.unitPriceLabel.Name = "unitPriceLabel";
            this.unitPriceLabel.Size = new System.Drawing.Size(80, 23);
            this.unitPriceLabel.TabIndex = 7;
            this.unitPriceLabel.Text = "ܰ";
            this.unitPriceLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // unitPriceNumericUpDown
            // 
            this.unitPriceNumericUpDown.DecimalPlaces = 2;
            this.unitPriceNumericUpDown.Increment = new decimal(new int[] {
            1,
            0,
            0,
            131072});
            this.unitPriceNumericUpDown.Location = new System.Drawing.Point(100, 140);
            this.unitPriceNumericUpDown.Name = "unitPriceNumericUpDown";
            this.unitPriceNumericUpDown.Size = new System.Drawing.Size(121, 23);
            this.unitPriceNumericUpDown.TabIndex = 8;
            // 
            // firstButton
            // 
            this.firstButton.Location = new System.Drawing.Point(20, 180);
            this.firstButton.Name = "firstButton";
            this.firstButton.Size = new System.Drawing.Size(30, 30);
            this.firstButton.TabIndex = 9;
            this.firstButton.Text = "";
            // 
            // previousButton
            // 
            this.previousButton.Location = new System.Drawing.Point(60, 180);
            this.previousButton.Name = "previousButton";
            this.previousButton.Size = new System.Drawing.Size(30, 30);
            this.previousButton.TabIndex = 10;
            this.previousButton.Text = "";
            // 
            // positionTextBox
            // 
            this.positionTextBox.Location = new System.Drawing.Point(100, 183);
            this.positionTextBox.Name = "positionTextBox";
            this.positionTextBox.Size = new System.Drawing.Size(270, 23);
            this.positionTextBox.TabIndex = 11;
            // 
            // nextButton
            // 
            this.nextButton.Location = new System.Drawing.Point(380, 180);
            this.nextButton.Name = "nextButton";
            this.nextButton.Size = new System.Drawing.Size(30, 30);
            this.nextButton.TabIndex = 12;
            this.nextButton.Text = "";
            // 
            // lastButton
            // 
            this.lastButton.Location = new System.Drawing.Point(420, 180);
            this.lastButton.Name = "lastButton";
            this.lastButton.Size = new System.Drawing.Size(30, 30);
            this.lastButton.TabIndex = 13;
            this.lastButton.Text = "";
            // 
            // ControlForm
            // 
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.None;
            this.ClientSize = new System.Drawing.Size(474, 231);
            this.Controls.Add(this.categoryLabel);
            this.Controls.Add(this.categoryComboBox);
            this.Controls.Add(this.productIDLabel);
            this.Controls.Add(this.productIDTextBox);
            this.Controls.Add(this.productNameLabel);
            this.Controls.Add(this.productNameTextBox);
            this.Controls.Add(this.discontinuedCheckBox);
            this.Controls.Add(this.unitPriceLabel);
            this.Controls.Add(this.unitPriceNumericUpDown);
            this.Controls.Add(this.firstButton);
            this.Controls.Add(this.previousButton);
            this.Controls.Add(this.positionTextBox);
            this.Controls.Add(this.nextButton);
            this.Controls.Add(this.lastButton);
            this.Font = new System.Drawing.Font("ڵ", 12F);
            this.Name = "ControlForm";
            this.Text = "Ʈ";
            ((System.ComponentModel.ISupportInitialize)(this.unitPriceNumericUpDown)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        #endregion
        #region ġ ϱ - UpdatePosition()

        /// <summary>
        /// ġ ϱ
        /// </summary>
        private void UpdatePosition()
        {
            BindingManagerBase bindingManagerBase;

            bindingManagerBase = BindingContext[this.masterDataSet, "ProductsExtended"];

            this.positionTextBox.Text =  "ǰ : ";
            this.positionTextBox.Text += (bindingManagerBase.Position + 1).ToString();
            this.positionTextBox.Text += " / ";
            this.positionTextBox.Text += bindingManagerBase.Count.ToString();
        }

        #endregion
    }
}