using System;
using System.Data;
using System.Data.Common;
using System.Data.OleDb;
using System.Globalization;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 
    /// </summary>
    public class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// īװ ID ̺
        /// </summary>
        private Label categoryIDLabel;

        /// <summary>
        /// īװ ID ؽƮ ڽ
        /// </summary>
        private TextBox categoryIDTextBox;

        /// <summary>
        /// īװ ̺
        /// </summary>
        private Label categoryNameLabel;

        /// <summary>
        /// īװ ؽƮ ڽ
        /// </summary>
        private TextBox categoryNameTextBox;

        /// <summary>
        ///  ؽƮ ڽ
        /// </summary>
        private TextBox descriptionTextBox;

        /// <summary>
        /// ǰ ̺
        /// </summary>
        private Label productLabel;

        /// <summary>
        /// ǰ Ʈ ڽ
        /// </summary>
        private ListBox productListBox;

        /// <summary>
        /// ֹ ̺
        /// </summary>
        private Label orderLabel;

        /// <summary>
        /// ֹ Ʈ ڽ
        /// </summary>
        private ListBox orderListBox;

        /// <summary>
        /// Ʈ ư
        /// </summary>
        private Button controlButton;

        /// <summary>
        ///  ׸ ư
        /// </summary>
        private Button dataGridButton;

        /// <summary>
        /// Ʈ  ư
        /// </summary>
        private Button treeViewButton;

        /// <summary>
        /// īװ ã ư
        /// </summary>
        private Button findCategoryButton;

        /// <summary>
        ///   ư
        /// </summary>
        private Button dataSetButton;
                    
        /// <summary>
        /// ù° ư
        /// </summary>
        private Button firstButton;

        /// <summary>
        ///  ư
        /// </summary>
        private Button previousButton;

        /// <summary>
        /// ġ ؽƮ ڽ
        /// </summary>
        private TextBox positionTextBox;

        /// <summary>
        ///  ư
        /// </summary>
        private Button nextButton;

        /// <summary>
        ///  ư
        /// </summary>
        private Button lastButton;

        /// <summary>
        /// 
        /// </summary>
        private OleDbConnection connection;

        /// <summary>
        ///   
        /// </summary>
        private MasterDataSet masterDataSet;

        /// <summary>
        /// īװ ȸ 
        /// </summary>
        private OleDbCommand selectCategoryCommand;

        /// <summary>
        /// ǰ ȸ 
        /// </summary>
        private OleDbCommand selectProductCommand;

        /// <summary>
        /// ֹ ȸ 
        /// </summary>
        private OleDbCommand selectOrderCommand;

        /// <summary>
        /// īװ 
        /// </summary>
        private OleDbDataAdapter catagoryAdapter;

        /// <summary>
        /// ǰ 
        /// </summary>
        private OleDbDataAdapter productAdapter;

        /// <summary>
        /// ֹ 
        /// </summary>
        private OleDbDataAdapter orderAdapter;
        
        /// <summary>
        ///    
        /// </summary>
        private ErrorProvider dataSetErrorProvider;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Consturctor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainForm()

        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            #region  Ѵ.

            this.connection = new OleDbConnection();

            this.connection.ConnectionString = UIHelper.GetMSAccess2007ConnectionString("nwind.mdb");

            #endregion
            #region  Ÿ  Ѵ.

            this.masterDataSet = new MasterDataSet();

            this.masterDataSet.DataSetName = "Master";
            this.masterDataSet.Locale      = new CultureInfo("en-US");
            this.masterDataSet.Namespace   = "http://www.tempuri.org/dsMaster.xsd";

            #endregion
            #region īװ ȸ  Ѵ.

            this.selectCategoryCommand = new OleDbCommand();

            this.selectCategoryCommand.Connection  = this.connection;
            this.selectCategoryCommand.CommandText = "SELECT CategoryID, CategoryName, Description FROM CategoriesByName";

            #endregion
            #region ǰ ȸ  Ѵ.

            this.selectProductCommand  = new OleDbCommand();

            this.selectProductCommand.Connection  = this.connection;
            this.selectProductCommand.CommandText = "SELECT CategoryID, ProductID, ProductName, SupplierID FROM ProductsByName";

            #endregion
            #region ֹ ȸ  Ѵ.

            this.selectOrderCommand = new OleDbCommand();

            this.selectOrderCommand.Connection  = this.connection;
            this.selectOrderCommand.CommandText = "SELECT OrderDate, ProductID FROM ProductOrderDates";

            #endregion
            #region īװ ͸ Ѵ.

            this.catagoryAdapter = new OleDbDataAdapter();

            this.catagoryAdapter.SelectCommand = this.selectCategoryCommand;

            this.catagoryAdapter.TableMappings.AddRange
            (
                new DataTableMapping[]
                {
                    new DataTableMapping
                    (
                        "Table",
                        "Categories",
                        new DataColumnMapping[]
                        {
                            new DataColumnMapping("CategoryID"  , "CategoryID"  ),
                            new DataColumnMapping("CategoryName", "CategoryName"),
                            new DataColumnMapping("Description" , "Description" )
                        }
                    )
                }
            );

            #endregion
            #region ǰ ͸ Ѵ.

            this.productAdapter = new OleDbDataAdapter();

            this.productAdapter.SelectCommand = this.selectProductCommand;

            this.productAdapter.TableMappings.AddRange
            (
                new DataTableMapping[]
                {
                    new DataTableMapping
                    (
                        "Table",
                        "Products",
                        new DataColumnMapping[]
                        {
                            new DataColumnMapping("ProductID"  , "ProductID"  ),
                            new DataColumnMapping("ProductName", "ProductName"),
                            new DataColumnMapping("SupplierID" , "SupplierID" ),
                            new DataColumnMapping("CategoryID" , "CategoryID" )
                        }
                    )
                }
            );

            #endregion
            #region ֹ ͸ Ѵ.

            this.orderAdapter = new OleDbDataAdapter();

            this.orderAdapter.SelectCommand = this.selectOrderCommand;

            this.orderAdapter.TableMappings.AddRange
            (
                new DataTableMapping[]
                {
                    new DataTableMapping
                    (
                        "Table",
                        "OrderDates",
                        new DataColumnMapping[]
                        {
                            new DataColumnMapping("ProductID", "ProductID"),
                            new DataColumnMapping("OrderDate", "OrderDate")
                        }
                    )
                }
            );

            #endregion

            #region    ڸ Ѵ.

            this.dataSetErrorProvider = new ErrorProvider();

            this.dataSetErrorProvider.ContainerControl = this;
            this.dataSetErrorProvider.DataSource       = this.masterDataSet;
            this.dataSetErrorProvider.DataMember       = "Categories";

            #endregion

            #region Ʈ ε Ѵ.

            this.categoryIDTextBox.DataBindings.Add  (new Binding("Text", this.masterDataSet, "Categories.CategoryID"  ));
            this.categoryNameTextBox.DataBindings.Add(new Binding("Text", this.masterDataSet, "Categories.CategoryName"));
            this.descriptionTextBox.DataBindings.Add (new Binding("Text", this.masterDataSet, "Categories.Description" ));

            this.productListBox.DataSource    = this.masterDataSet;
            this.productListBox.DisplayMember = "Categories.CategoriesProducts.ProductName";
            this.productListBox.ValueMember   = "Products.ProductID";

            this.orderListBox.DataSource      = this.masterDataSet;
            this.orderListBox.DisplayMember   = "Categories.CategoriesProducts.ProductOrders.OrderDate";

            #endregion
            #region ̺Ʈ Ѵ.

            this.controlButton.Click      += controlButton_Click;
            this.dataGridButton.Click     += dataGridButton_Click;
            this.treeViewButton.Click     += treeViewButton_Click;
            this.findCategoryButton.Click += findCategoryButton_Click;
            this.dataSetButton.Click      += dataSetButton_Click;
            this.firstButton.Click        += firstButton_Click;
            this.previousButton.Click     += previousButton_Click;           
            this.nextButton.Click         += nextButton_Click;
            this.lastButton.Click         += lastButton_Click;

            #endregion

            this.catagoryAdapter.Fill(this.masterDataSet.Categories);
            this.productAdapter.Fill (this.masterDataSet.Products  );
            this.orderAdapter.Fill   (this.masterDataSet.OrderDates);

            this.masterDataSet.Categories.DefaultView.Sort = "CategoryID";

            UpdatePosition();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region Ʈ ư Ŭ óϱ - controlButton_Click(senser, e)

        /// <summary>
        /// Ʈ ư Ŭ óϱ
        /// </summary>
        /// <param name="senser">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
        private void controlButton_Click(object senser, EventArgs e)
        {
            ControlForm form = new ControlForm();

            form.Show();
        }

        #endregion
        #region  ׸ ư Ŭ óϱ - dataGridButton_Click(senser, e)

        /// <summary>
        ///  ׸ ư Ŭ óϱ
        /// </summary>
        /// <param name="senser">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
        private void dataGridButton_Click(object senser, EventArgs e)
        {
            DataGridForm form = new DataGridForm();

            form.Show();
        }

        #endregion
        #region Ʈ  ư Ŭ óϱ - treeViewButton_Click(senser, e)

        /// <summary>
        /// Ʈ  ư Ŭ óϱ
        /// </summary>
        /// <param name="senser">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
        private void treeViewButton_Click(object senser, EventArgs e)
        {
            TreeViewForm form = new TreeViewForm();

            form.Show();
        }

        #endregion
        #region īװ ã ư Ŭ óϱ - findCategoryButton_Click(senser, e)

        /// <summary>
        /// īװ ã ư Ŭ óϱ
        /// </summary>
        /// <param name="senser">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
        private void findCategoryButton_Click(object senser, EventArgs e)
        {
            FindCategoryForm form     = new FindCategoryForm();
            DataView         dataView = this.masterDataSet.Categories.DefaultView;
            int              categoryID;
            int              index;

            if(form.ShowDialog() == DialogResult.OK)
            {
                if(form.CategoryID == 0)
                {
                    string                      categoryName;
                    DataTable                   dataTable = this.masterDataSet.Categories;
                    MasterDataSet.CategoriesRow categoriesRow;
                    DataRow[]                   dataRowArray;

                    categoryName = form.CategoryName;

                    try
                    {
                        dataRowArray = dataTable.Select("CategoryName = '" + categoryName + "'");

                        categoriesRow = (MasterDataSet.CategoriesRow)dataRowArray[0];

                        categoryID = categoriesRow.CategoryID;

                        index = dataView.Find(categoryID);

                        BindingContext[this.masterDataSet, "Categories"].Position = index;
                    }
                    catch
                    {
                        MessageBox.Show("Category " + categoryName + " not found", "Error");
                    }
                }
                else
                {
                    categoryID = form.CategoryID;

                    index = dataView.Find(categoryID);

                    if(index == -1)
                    {
                        MessageBox.Show("Category " + categoryID.ToString(), "Error");
                    }
                    else
                    {
                        BindingContext[this.masterDataSet, "Categories"].Position = index;
                    }
                }
            }

            form.Dispose();
        }

        #endregion
        #region   ư Ŭ óϱ - dataSetButton_Click(senser, e)

        /// <summary>
        ///   ư Ŭ óϱ
        /// </summary>
        /// <param name="senser">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
        private void dataSetButton_Click(object senser, EventArgs e)
        {
            this.masterDataSet.Categories.Rows[0].SetColumnError("Description", "Error Created Here");
        }

        #endregion
        #region ó ư Ŭ óϱ - firstButton_Click(senser, e)

        /// <summary>
        /// ó ư Ŭ óϱ
        /// </summary>
        /// <param name="senser">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
        private void firstButton_Click(object senser, EventArgs e)
        {
            BindingContext[this.masterDataSet, "Categories"].Position = 0;

            UpdatePosition();
        }

        #endregion
        #region  ư Ŭ óϱ - previousButton_Click(senser, e)

        /// <summary>
        ///  ư Ŭ óϱ
        /// </summary>
        /// <param name="senser">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
        private void previousButton_Click(object senser, EventArgs e)
        {
            BindingContext[this.masterDataSet, "Categories"].Position -= 1;

            UpdatePosition();
        }

        #endregion
        #region  ư Ŭ óϱ - nextButton_Click(senser, e)

        /// <summary>
        ///  ư Ŭ óϱ
        /// </summary>
        /// <param name="senser">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
        private void nextButton_Click(object senser, EventArgs e)
        {
            BindingContext[this.masterDataSet, "Categories"].Position += 1;

            UpdatePosition();
        }

        #endregion
        #region  ư Ŭ óϱ - lastButton_Click(senser, e)

        /// <summary>
        ///  ư Ŭ óϱ
        /// </summary>
        /// <param name="senser">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
        private void lastButton_Click(object senser, EventArgs e)
        {
            BindingContext[this.masterDataSet, "Categories"].Position = BindingContext[this.masterDataSet, "Categories"].Count - 1;

            UpdatePosition();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region Ʈ ʱȭ ϱ - InitializeComponent()

        /// <summary>
        /// Ʈ ʱȭ ϱ
        /// </summary>
        private void InitializeComponent()
        {
            this.categoryIDLabel = new System.Windows.Forms.Label();
            this.categoryIDTextBox = new System.Windows.Forms.TextBox();
            this.categoryNameLabel = new System.Windows.Forms.Label();
            this.categoryNameTextBox = new System.Windows.Forms.TextBox();
            this.descriptionTextBox = new System.Windows.Forms.TextBox();
            this.productLabel = new System.Windows.Forms.Label();
            this.productListBox = new System.Windows.Forms.ListBox();
            this.orderLabel = new System.Windows.Forms.Label();
            this.orderListBox = new System.Windows.Forms.ListBox();
            this.controlButton = new System.Windows.Forms.Button();
            this.dataGridButton = new System.Windows.Forms.Button();
            this.treeViewButton = new System.Windows.Forms.Button();
            this.findCategoryButton = new System.Windows.Forms.Button();
            this.dataSetButton = new System.Windows.Forms.Button();
            this.firstButton = new System.Windows.Forms.Button();
            this.previousButton = new System.Windows.Forms.Button();
            this.positionTextBox = new System.Windows.Forms.TextBox();
            this.nextButton = new System.Windows.Forms.Button();
            this.lastButton = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // categoryIDLabel
            // 
            this.categoryIDLabel.Font = new System.Drawing.Font("ڵ", 12F);
            this.categoryIDLabel.Location = new System.Drawing.Point(20, 20);
            this.categoryIDLabel.Name = "categoryIDLabel";
            this.categoryIDLabel.Size = new System.Drawing.Size(100, 23);
            this.categoryIDLabel.TabIndex = 0;
            this.categoryIDLabel.Text = "īװ ID";
            this.categoryIDLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // categoryIDTextBox
            // 
            this.categoryIDTextBox.Location = new System.Drawing.Point(120, 20);
            this.categoryIDTextBox.Margin = new System.Windows.Forms.Padding(0);
            this.categoryIDTextBox.Name = "categoryIDTextBox";
            this.categoryIDTextBox.Size = new System.Drawing.Size(310, 23);
            this.categoryIDTextBox.TabIndex = 1;
            // 
            // categoryNameLabel
            // 
            this.categoryNameLabel.Font = new System.Drawing.Font("ڵ", 12F);
            this.categoryNameLabel.Location = new System.Drawing.Point(20, 50);
            this.categoryNameLabel.Name = "categoryNameLabel";
            this.categoryNameLabel.Size = new System.Drawing.Size(100, 23);
            this.categoryNameLabel.TabIndex = 2;
            this.categoryNameLabel.Text = "īװ";
            this.categoryNameLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // categoryNameTextBox
            // 
            this.categoryNameTextBox.Location = new System.Drawing.Point(120, 50);
            this.categoryNameTextBox.Margin = new System.Windows.Forms.Padding(0);
            this.categoryNameTextBox.Name = "categoryNameTextBox";
            this.categoryNameTextBox.Size = new System.Drawing.Size(310, 23);
            this.categoryNameTextBox.TabIndex = 3;
            // 
            // descriptionTextBox
            // 
            this.descriptionTextBox.Location = new System.Drawing.Point(20, 80);
            this.descriptionTextBox.Margin = new System.Windows.Forms.Padding(0);
            this.descriptionTextBox.Name = "descriptionTextBox";
            this.descriptionTextBox.Size = new System.Drawing.Size(410, 23);
            this.descriptionTextBox.TabIndex = 4;
            // 
            // productLabel
            // 
            this.productLabel.Font = new System.Drawing.Font("ڵ", 12F);
            this.productLabel.Location = new System.Drawing.Point(20, 110);
            this.productLabel.Name = "productLabel";
            this.productLabel.Size = new System.Drawing.Size(100, 23);
            this.productLabel.TabIndex = 5;
            this.productLabel.Text = "ǰ";
            this.productLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // productListBox
            // 
            this.productListBox.IntegralHeight = false;
            this.productListBox.ItemHeight = 16;
            this.productListBox.Location = new System.Drawing.Point(20, 140);
            this.productListBox.Margin = new System.Windows.Forms.Padding(0);
            this.productListBox.Name = "productListBox";
            this.productListBox.Size = new System.Drawing.Size(200, 250);
            this.productListBox.TabIndex = 7;
            // 
            // orderLabel
            // 
            this.orderLabel.Font = new System.Drawing.Font("ڵ", 12F);
            this.orderLabel.Location = new System.Drawing.Point(230, 110);
            this.orderLabel.Name = "orderLabel";
            this.orderLabel.Size = new System.Drawing.Size(100, 23);
            this.orderLabel.TabIndex = 6;
            this.orderLabel.Text = "ֹ";
            this.orderLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // orderListBox
            // 
            this.orderListBox.IntegralHeight = false;
            this.orderListBox.ItemHeight = 16;
            this.orderListBox.Location = new System.Drawing.Point(230, 140);
            this.orderListBox.Margin = new System.Windows.Forms.Padding(0);
            this.orderListBox.Name = "orderListBox";
            this.orderListBox.Size = new System.Drawing.Size(200, 250);
            this.orderListBox.TabIndex = 8;
            // 
            // controlButton
            // 
            this.controlButton.Location = new System.Drawing.Point(450, 20);
            this.controlButton.Margin = new System.Windows.Forms.Padding(0);
            this.controlButton.Name = "controlButton";
            this.controlButton.Size = new System.Drawing.Size(130, 30);
            this.controlButton.TabIndex = 14;
            this.controlButton.Text = "Ʈ";
            // 
            // dataGridButton
            // 
            this.dataGridButton.Location = new System.Drawing.Point(450, 60);
            this.dataGridButton.Margin = new System.Windows.Forms.Padding(0);
            this.dataGridButton.Name = "dataGridButton";
            this.dataGridButton.Size = new System.Drawing.Size(130, 30);
            this.dataGridButton.TabIndex = 15;
            this.dataGridButton.Text = " ׸";
            // 
            // treeViewButton
            // 
            this.treeViewButton.Location = new System.Drawing.Point(450, 100);
            this.treeViewButton.Margin = new System.Windows.Forms.Padding(0);
            this.treeViewButton.Name = "treeViewButton";
            this.treeViewButton.Size = new System.Drawing.Size(130, 30);
            this.treeViewButton.TabIndex = 16;
            this.treeViewButton.Text = "Ʈ ";
            // 
            // findCategoryButton
            // 
            this.findCategoryButton.Location = new System.Drawing.Point(450, 140);
            this.findCategoryButton.Margin = new System.Windows.Forms.Padding(0);
            this.findCategoryButton.Name = "findCategoryButton";
            this.findCategoryButton.Size = new System.Drawing.Size(130, 30);
            this.findCategoryButton.TabIndex = 17;
            this.findCategoryButton.Text = "ã";
            // 
            // dataSetButton
            // 
            this.dataSetButton.Location = new System.Drawing.Point(450, 180);
            this.dataSetButton.Margin = new System.Windows.Forms.Padding(0);
            this.dataSetButton.Name = "dataSetButton";
            this.dataSetButton.Size = new System.Drawing.Size(130, 30);
            this.dataSetButton.TabIndex = 18;
            this.dataSetButton.Text = " ";
            // 
            // firstButton
            // 
            this.firstButton.Location = new System.Drawing.Point(20, 400);
            this.firstButton.Margin = new System.Windows.Forms.Padding(0);
            this.firstButton.Name = "firstButton";
            this.firstButton.Size = new System.Drawing.Size(30, 30);
            this.firstButton.TabIndex = 9;
            this.firstButton.Text = "";
            // 
            // previousButton
            // 
            this.previousButton.Location = new System.Drawing.Point(60, 400);
            this.previousButton.Margin = new System.Windows.Forms.Padding(0);
            this.previousButton.Name = "previousButton";
            this.previousButton.Size = new System.Drawing.Size(30, 30);
            this.previousButton.TabIndex = 10;
            this.previousButton.Text = "";
            // 
            // positionTextBox
            // 
            this.positionTextBox.Location = new System.Drawing.Point(100, 404);
            this.positionTextBox.Margin = new System.Windows.Forms.Padding(0);
            this.positionTextBox.Name = "positionTextBox";
            this.positionTextBox.Size = new System.Drawing.Size(250, 23);
            this.positionTextBox.TabIndex = 11;
            // 
            // nextButton
            // 
            this.nextButton.Location = new System.Drawing.Point(360, 400);
            this.nextButton.Margin = new System.Windows.Forms.Padding(0);
            this.nextButton.Name = "nextButton";
            this.nextButton.Size = new System.Drawing.Size(30, 30);
            this.nextButton.TabIndex = 12;
            this.nextButton.Text = "";
            // 
            // lastButton
            // 
            this.lastButton.Location = new System.Drawing.Point(400, 400);
            this.lastButton.Margin = new System.Windows.Forms.Padding(0);
            this.lastButton.Name = "lastButton";
            this.lastButton.Size = new System.Drawing.Size(30, 30);
            this.lastButton.TabIndex = 13;
            this.lastButton.Text = "";
            // 
            // MainForm
            // 
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.None;
            this.ClientSize = new System.Drawing.Size(604, 451);
            this.Controls.Add(this.categoryIDLabel);
            this.Controls.Add(this.categoryIDTextBox);
            this.Controls.Add(this.categoryNameLabel);
            this.Controls.Add(this.categoryNameTextBox);
            this.Controls.Add(this.descriptionTextBox);
            this.Controls.Add(this.productLabel);
            this.Controls.Add(this.productListBox);
            this.Controls.Add(this.orderLabel);
            this.Controls.Add(this.orderListBox);
            this.Controls.Add(this.controlButton);
            this.Controls.Add(this.dataGridButton);
            this.Controls.Add(this.treeViewButton);
            this.Controls.Add(this.findCategoryButton);
            this.Controls.Add(this.dataSetButton);
            this.Controls.Add(this.firstButton);
            this.Controls.Add(this.previousButton);
            this.Controls.Add(this.positionTextBox);
            this.Controls.Add(this.nextButton);
            this.Controls.Add(this.lastButton);
            this.Font = new System.Drawing.Font("ڵ", 12F);
            this.Margin = new System.Windows.Forms.Padding(3, 4, 3, 4);
            this.Name = "MainForm";
            this.Text = "Ʈ ε ׽Ʈ";
            this.ResumeLayout(false);
            this.PerformLayout();

        }

        #endregion
        #region ġ ϱ - UpdatePosition()

        /// <summary>
        /// ġ ϱ
        /// </summary>
        private void UpdatePosition()
        {
            BindingManagerBase bindingManagerBase;

            bindingManagerBase = BindingContext[this.masterDataSet, "Categories"];

            this.positionTextBox.Text =  "īװ : ";
            this.positionTextBox.Text += (bindingManagerBase.Position + 1).ToString();
            this.positionTextBox.Text += " / ";
            this.positionTextBox.Text += bindingManagerBase.Count.ToString();
        }

        #endregion
    }
}