using System;
using System.Data;
using System.Data.Common;
using System.Data.OleDb;
using System.Drawing;
using System.Globalization;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// Ʈ 
    /// </summary>
	public class TreeViewForm : Form
	{
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// īװ ID ̺
        /// </summary>
        private Label categoryIDLabel;

        /// <summary>
        /// īװ ID ؽƮ ڽ
        /// </summary>
        private TextBox categoryIDTextBox;

        /// <summary>
        /// īװ ̺
        /// </summary>
        private Label categoryNameLabel;

        /// <summary>
        /// īװ ؽƮ ڽ
        /// </summary>
        private TextBox categoryNameTextBox;

        /// <summary>
        ///  ؽƮ ڽ
        /// </summary>
        private TextBox descriptionTextBox;

        /// <summary>
        /// ǰ ֹ Ʈ 
        /// </summary>
        private TreeView productOrderTreeView;

        /// <summary>
        /// ù° ư
        /// </summary>
        private Button firstButton;

        /// <summary>
        ///  ư
        /// </summary>
        private Button previousButton;

        /// <summary>
        /// ġ ؽƮ ڽ
        /// </summary>
        private TextBox positionTextBox;

        /// <summary>
        ///  ư
        /// </summary>
        private Button nextButton;

        /// <summary>
        ///  ư
        /// </summary>
        private Button lastButton;


        /// <summary>
        /// 
        /// </summary>
        private OleDbConnection connection;

        /// <summary>
        ///   
        /// </summary>
        private MasterDataSet masterDataSet;

        /// <summary>
        /// īװ ȸ 
        /// </summary>
        private OleDbCommand selectCategoryCommand;

        /// <summary>
        /// ǰ ȸ 
        /// </summary>
        private OleDbCommand selectProductCommand;

        /// <summary>
        /// ֹ 
        /// </summary>
        private OleDbCommand selectOrderCommand;

        /// <summary>
        /// īװ 
        /// </summary>
        private OleDbDataAdapter categoryAdapter;

        /// <summary>
        /// ǰ 
        /// </summary>
        private OleDbDataAdapter productAdapter;

        /// <summary>
        /// ֹ 
        /// </summary>
        private OleDbDataAdapter orderAdapter;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - TreeViewForm()

        /// <summary>
        /// 
        /// </summary>
        public TreeViewForm()
        {
            InitializeComponent();

            #region  Ѵ.

			this.connection = new OleDbConnection();

            this.connection.ConnectionString = UIHelper.GetMSAccess2007ConnectionString("nwind.mdb");

            #endregion
            #region    Ѵ.

			this.masterDataSet = new MasterDataSet();

            this.masterDataSet.DataSetName = "Master";
            this.masterDataSet.Locale      = new CultureInfo("en-US");
            this.masterDataSet.Namespace   = "http://www.tempuri.org/dsMaster.xsd";

            #endregion
            #region īװ ȸ  Ѵ.

			this.selectCategoryCommand = new OleDbCommand();

			this.selectCategoryCommand.Connection  = this.connection;
			this.selectCategoryCommand.CommandText = "SELECT CategoryID, CategoryName, Description FROM CategoriesByName";

            #endregion
            #region ǰ ȸ  Ѵ.

			this.selectProductCommand = new OleDbCommand();

            this.selectProductCommand.Connection  = this.connection;
            this.selectProductCommand.CommandText = "SELECT CategoryID, ProductID, ProductName, SupplierID FROM ProductsByName";

            #endregion
            #region ֹ ȸ  Ѵ.

			this.selectOrderCommand = new OleDbCommand();

            this.selectOrderCommand.Connection = this.connection;
            this.selectOrderCommand.CommandText = "SELECT OrderDate, ProductID FROM ProductOrderDates";

            #endregion
            #region īװ ͸ Ѵ.

			this.categoryAdapter = new OleDbDataAdapter();

            this.categoryAdapter.SelectCommand = this.selectCategoryCommand;

            this.categoryAdapter.TableMappings.AddRange
            (
                new DataTableMapping[]
                {
                    new DataTableMapping
                    (
                        "Table",
                        "Categories",
                        new DataColumnMapping[]
                        {
                            new DataColumnMapping("CategoryID"  , "CategoryID"  ),
                            new DataColumnMapping("CategoryName", "CategoryName"),
                            new DataColumnMapping("Description" , "Description" )
                        }
                    )
                }
            );

            #endregion
            #region ǰ ͸ Ѵ.

			this.productAdapter = new OleDbDataAdapter();

            this.productAdapter.SelectCommand = this.selectProductCommand;

            this.productAdapter.TableMappings.AddRange
            (
                new DataTableMapping[]
                {
                    new DataTableMapping
                    (
                        "Table",
                        "Products",
                        new DataColumnMapping[]
                        {
                            new DataColumnMapping("ProductID"  , "ProductID"  ),
                            new DataColumnMapping("ProductName", "ProductName"),
                            new DataColumnMapping("SupplierID" , "SupplierID" ),
                            new DataColumnMapping("CategoryID" , "CategoryID" )
                        }
                    )
                }
            );

            #endregion
            #region ֹ ͸ Ѵ.

			this.orderAdapter = new OleDbDataAdapter();

            this.orderAdapter.SelectCommand = this.selectOrderCommand;

            this.orderAdapter.TableMappings.AddRange
            (
                new DataTableMapping[]
                {
                    new DataTableMapping
                    (
                        "Table",
                        "OrderDates",
                        new DataColumnMapping[]
                        {
                            new DataColumnMapping("ProductID", "ProductID"),
                            new DataColumnMapping("OrderDate", "OrderDate")
                        }
                    )
                }
            );

            #endregion

            #region ε Ѵ.

            this.categoryIDTextBox.DataBindings.Add  (new Binding("Text", this.masterDataSet, "Categories.CategoryID"  ));
            this.categoryNameTextBox.DataBindings.Add(new Binding("Text", this.masterDataSet, "Categories.CategoryName"));
            this.descriptionTextBox.DataBindings.Add (new Binding("Text", this.masterDataSet, "Categories.Description" ));

            #endregion
            #region ̺Ʈ Ѵ.

			BindingContext[this.masterDataSet, "Categories"].PositionChanged += BindingManagerBase_PositionChanged;

            this.firstButton.Click    += firstButton_Click;
            this.previousButton.Click += previousButton_Click;
            this.nextButton.Click     += nextButton_Click;
            this.lastButton.Click     += lastButton_Click;

            #endregion

			this.categoryAdapter.Fill(this.masterDataSet.Categories);
			this.productAdapter.Fill (this.masterDataSet.Products  );
			this.orderAdapter.Fill   (this.masterDataSet.OrderDates);

			UpdatePosition();

			BindingManagerBase_PositionChanged(this, EventArgs.Empty);
		}

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region ó ư Ŭ óϱ - firstButton_Click(sender, e)

        /// <summary>
        /// ó ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
		private void firstButton_Click(object sender, EventArgs e)
		{
			BindingContext[this.masterDataSet, "Categories"].Position = 0;

			UpdatePosition();
		}

        #endregion
        #region  ư Ŭ óϱ - previousButton_Click(sender, e)

        /// <summary>
        ///  ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
		private void previousButton_Click(object sender, EventArgs e)
		{
			BindingContext[this.masterDataSet, "Categories"].Position -= 1;

			UpdatePosition();
		}

        #endregion
        #region  ư Ŭ óϱ - nextButton_Click(sender, e)

        /// <summary>
        ///  ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
		private void nextButton_Click(object sender, EventArgs e)
		{
			BindingContext[this.masterDataSet, "Categories"].Position += 1;

			UpdatePosition();
		}

        #endregion
        #region  ư Ŭ óϱ - lastButton_Click(sender, e)

        /// <summary>
        ///  ư Ŭ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
		private void lastButton_Click(object sender, EventArgs e)
		{
			BindingContext[this.masterDataSet, "Categories"].Position = BindingContext[this.masterDataSet, "Categories"].Count - 1;

			UpdatePosition();
		}

		#endregion
        #region ε  ̽ ġ  óϱ - BindingManagerBase_PositionChanged(sender, e)

        /// <summary>
        /// ε  ̽ ġ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻ ü</param>
        /// <param name="e">̺Ʈ </param>
		private void BindingManagerBase_PositionChanged(object sender, EventArgs e)
		{
			DataRowView categoryDataRowView;
			DataRow[]   productDataRowArray;
			DataRow[]   orderDataRowArray;
			TreeNode    treeNode;
			TreeView    treeView;

			treeView = this.productOrderTreeView;
	
			treeView.BeginUpdate();

            treeView.Nodes.Clear();

			categoryDataRowView = (DataRowView)BindingContext[this.masterDataSet, "Categories"].Current;

			productDataRowArray = categoryDataRowView.Row.GetChildRows("CategoriesProducts");

			foreach(MasterDataSet.ProductsRow productRow in productDataRowArray)
			{
				treeNode = treeView.Nodes.Add(productRow.ProductName);

				orderDataRowArray = productRow.GetChildRows("ProductOrders");

				foreach(MasterDataSet.OrderDatesRow oOrderDatesRow in orderDataRowArray)
				{
					treeNode.Nodes.Add(oOrderDatesRow.OrderDate.ToString());
				}
				
			}

			treeView.EndUpdate();
		}

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region Ʈ ʱȭ ϱ - InitializeComponent()

        /// <summary>
        /// Ʈ ʱȭ ϱ
        /// </summary>
		private void InitializeComponent()
		{
            this.categoryIDLabel = new System.Windows.Forms.Label();
            this.categoryIDTextBox = new System.Windows.Forms.TextBox();
            this.categoryNameLabel = new System.Windows.Forms.Label();
            this.categoryNameTextBox = new System.Windows.Forms.TextBox();
            this.descriptionTextBox = new System.Windows.Forms.TextBox();
            this.productOrderTreeView = new System.Windows.Forms.TreeView();
            this.firstButton = new System.Windows.Forms.Button();
            this.previousButton = new System.Windows.Forms.Button();
            this.positionTextBox = new System.Windows.Forms.TextBox();
            this.nextButton = new System.Windows.Forms.Button();
            this.lastButton = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // categoryIDLabel
            // 
            this.categoryIDLabel.Font = new System.Drawing.Font("ڵ", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.categoryIDLabel.Location = new System.Drawing.Point(20, 20);
            this.categoryIDLabel.Margin = new System.Windows.Forms.Padding(0);
            this.categoryIDLabel.Name = "categoryIDLabel";
            this.categoryIDLabel.Size = new System.Drawing.Size(100, 23);
            this.categoryIDLabel.TabIndex = 0;
            this.categoryIDLabel.Text = "īװ ID";
            this.categoryIDLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // categoryIDTextBox
            // 
            this.categoryIDTextBox.Location = new System.Drawing.Point(120, 20);
            this.categoryIDTextBox.Margin = new System.Windows.Forms.Padding(0);
            this.categoryIDTextBox.Name = "categoryIDTextBox";
            this.categoryIDTextBox.Size = new System.Drawing.Size(300, 23);
            this.categoryIDTextBox.TabIndex = 1;
            // 
            // categoryNameLabel
            // 
            this.categoryNameLabel.Font = new System.Drawing.Font("ڵ", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.categoryNameLabel.Location = new System.Drawing.Point(20, 50);
            this.categoryNameLabel.Margin = new System.Windows.Forms.Padding(0);
            this.categoryNameLabel.Name = "categoryNameLabel";
            this.categoryNameLabel.Size = new System.Drawing.Size(100, 23);
            this.categoryNameLabel.TabIndex = 2;
            this.categoryNameLabel.Text = "īװ";
            this.categoryNameLabel.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // categoryNameTextBox
            // 
            this.categoryNameTextBox.Location = new System.Drawing.Point(120, 50);
            this.categoryNameTextBox.Margin = new System.Windows.Forms.Padding(0);
            this.categoryNameTextBox.Name = "categoryNameTextBox";
            this.categoryNameTextBox.Size = new System.Drawing.Size(300, 23);
            this.categoryNameTextBox.TabIndex = 3;
            // 
            // descriptionTextBox
            // 
            this.descriptionTextBox.Location = new System.Drawing.Point(20, 80);
            this.descriptionTextBox.Margin = new System.Windows.Forms.Padding(3, 4, 3, 4);
            this.descriptionTextBox.Name = "descriptionTextBox";
            this.descriptionTextBox.Size = new System.Drawing.Size(400, 23);
            this.descriptionTextBox.TabIndex = 4;
            // 
            // productOrderTreeView
            // 
            this.productOrderTreeView.Location = new System.Drawing.Point(20, 115);
            this.productOrderTreeView.Margin = new System.Windows.Forms.Padding(0);
            this.productOrderTreeView.Name = "productOrderTreeView";
            this.productOrderTreeView.Size = new System.Drawing.Size(400, 300);
            this.productOrderTreeView.TabIndex = 5;
            // 
            // firstButton
            // 
            this.firstButton.Location = new System.Drawing.Point(20, 430);
            this.firstButton.Margin = new System.Windows.Forms.Padding(0);
            this.firstButton.Name = "firstButton";
            this.firstButton.Size = new System.Drawing.Size(30, 30);
            this.firstButton.TabIndex = 6;
            this.firstButton.Text = "";
            // 
            // previousButton
            // 
            this.previousButton.Location = new System.Drawing.Point(60, 430);
            this.previousButton.Margin = new System.Windows.Forms.Padding(0);
            this.previousButton.Name = "previousButton";
            this.previousButton.Size = new System.Drawing.Size(30, 30);
            this.previousButton.TabIndex = 7;
            this.previousButton.Text = "";
            // 
            // positionTextBox
            // 
            this.positionTextBox.Location = new System.Drawing.Point(100, 433);
            this.positionTextBox.Margin = new System.Windows.Forms.Padding(0);
            this.positionTextBox.Name = "positionTextBox";
            this.positionTextBox.Size = new System.Drawing.Size(240, 23);
            this.positionTextBox.TabIndex = 8;
            // 
            // nextButton
            // 
            this.nextButton.Location = new System.Drawing.Point(350, 430);
            this.nextButton.Margin = new System.Windows.Forms.Padding(0);
            this.nextButton.Name = "nextButton";
            this.nextButton.Size = new System.Drawing.Size(30, 30);
            this.nextButton.TabIndex = 9;
            this.nextButton.Text = "";
            // 
            // lastButton
            // 
            this.lastButton.Location = new System.Drawing.Point(390, 430);
            this.lastButton.Margin = new System.Windows.Forms.Padding(0);
            this.lastButton.Name = "lastButton";
            this.lastButton.Size = new System.Drawing.Size(30, 30);
            this.lastButton.TabIndex = 10;
            this.lastButton.Text = "";
            // 
            // TreeViewForm
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(8F, 16F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(434, 481);
            this.Controls.Add(this.categoryIDLabel);
            this.Controls.Add(this.categoryIDTextBox);
            this.Controls.Add(this.categoryNameLabel);
            this.Controls.Add(this.categoryNameTextBox);
            this.Controls.Add(this.descriptionTextBox);
            this.Controls.Add(this.productOrderTreeView);
            this.Controls.Add(this.firstButton);
            this.Controls.Add(this.previousButton);
            this.Controls.Add(this.positionTextBox);
            this.Controls.Add(this.nextButton);
            this.Controls.Add(this.lastButton);
            this.Font = new System.Drawing.Font("ڵ", 12F);
            this.Margin = new System.Windows.Forms.Padding(3, 4, 3, 4);
            this.Name = "TreeViewForm";
            this.Text = "Ʈ ";
            this.ResumeLayout(false);
            this.PerformLayout();

		}

		#endregion
        #region ġ ϱ - UpdatePosition()

        /// <summary>
        /// ġ ϱ
        /// </summary>
        private void UpdatePosition()
        {
            BindingManagerBase bindingManagerBase;

            bindingManagerBase = BindingContext[this.masterDataSet, "Categories"];

            this.positionTextBox.Text =  "īװ : ";
            this.positionTextBox.Text += (bindingManagerBase.Position + 1).ToString();
            this.positionTextBox.Text += " / ";
            this.positionTextBox.Text += bindingManagerBase.Count.ToString();
        }

		#endregion	
    }
}